<?php

namespace Pinpoint\PaginationCanonicalTags\Plugin\Magento\Catalog\Helper;

use Magento\Catalog\Helper\Category as Subject;
use Pinpoint\PaginationCanonicalTags\Helper\Request as RequestHelper;

class Category
{
    /**
     * @var RequestHelper
     */
    private $requestHelper;

    /**
     * @param RequestHelper $requestHelper
     */
    public function __construct(
        RequestHelper $requestHelper
    ) {
        $this->requestHelper = $requestHelper;
    }

    /**
     * Plugin to prevent Magento module from adding canonical URL if we are adding our own, to prevent duplicates
     *
     * @param Subject $subject
     * @param boolean $result
     * @return boolean
     */
    public function afterCanUseCanonicalTag(Subject $subject, bool $result): bool
    {
        if ($this->requestHelper->isToAddCanonicalTag()) {
            return false;
        }

        return $result;
    }
}
