<?php

namespace Pinpoint\PaginationCanonicalTags\ViewModel;

use Magento\Framework\UrlInterface;
use Magento\Framework\View\Element\Block\ArgumentInterface;
use Pinpoint\PaginationCanonicalTags\Helper\Request as RequestHelper;

class Tags implements ArgumentInterface
{
    /**
     * @var UrlInterface
     */
    private $url;

    /**
     * @var RequestHelper
     */
    private $requestHelper;

    /**
     * @param UrlInterface  $url
     * @param RequestHelper $requestHelper
     */
    public function __construct(
        UrlInterface $url,
        RequestHelper $requestHelper
    ) {
        $this->url = $url;
        $this->requestHelper = $requestHelper;
    }

    /**
     * Returns if we should show a self-referencing canonical tag
     *
     * @return boolean
     */
    public function isToAddCanonicalTag(): bool
    {
        return $this->requestHelper->isToAddCanonicalTag();
    }

    /**
     * Returns the self-reference canonical URL to append to the document head
     *
     * @return string
     */
    public function getCanonicalUrl(): string
    {
        return (string) $this->url->getCurrentUrl();
    }
}
